/*
 * Code generated by MGUI Designer
 */

#include <stdio.h>
#include <stdlib.h>
#include "mgui.h"

/*
 * External User Defined Callbacks
 */
void OpenCB(MOBJECT p, void *od, void *ad);
void SaveCB(MOBJECT p, void *od, void *ad);
void SaveAsCB(MOBJECT p, void *od, void *ad);
void RevertCB(MOBJECT p, void *od, void *ad);
void FontSelectCB(MOBJECT p, void *od, void *ad);
void FontSelectCB(MOBJECT p, void *od, void *ad);
/*
 * Global Variables
 */
MOBJECT main_shell;
MOBJECT options_pd      ;
PULLDOWN_ITEM	default_font_i;
MOBJECT filename_l;
MOBJECT modified_l;
MOBJECT curs_y_l;
MOBJECT curs_x_l;
MOBJECT text_mle;
MOBJECT search_shell;
MOBJECT search_e;
MOBJECT ignore_case_tb;
MOBJECT search_f_pb;
MOBJECT search_b_pb;
MOBJECT search_cancel_pb;
MOBJECT gotoline_shell;
MOBJECT gotoline_e;
MOBJECT gotoline_ok_pb;
MOBJECT replace_shell;
MOBJECT replace_r_e;
MOBJECT replace_w_e;
MOBJECT replace_one_pb;
MOBJECT replace_some_pb;
MOBJECT replace_all_pb;
MOBJECT replace_canc_pb;
/*
 * User Code
 */
#include <string.h>

#include "me.h"

PULLDOWN_ITEM	selected_font_item;
int		ignore_case;
/*
 * END of User Code
 */

/*
 * Shell creation prototypes
 */
MOBJECT MDCreatemain_shell(void);
MOBJECT MDCreatesearch_shell(void);
MOBJECT MDCreategotoline_shell(void);
MOBJECT MDCreatereplace_shell(void);

/*
 * Project Defined Callbacks
 */
void QuitCB(MOBJECT p, void *od, void *ud)
{
	FILE_DATA *pfd;
	MOBJECT	shell = (MOBJECT)ud;
	int	ret;

	pfd = MObjectGetUserData(shell);
	if (pfd && pfd->modified) {
		ret = MMessageDialog("Warning",
			"Save this file before exiting ?",
			" Yes ", " No ", " Cancel ", NULL);
		if (ret == 0)
			SaveCB(p, od, ud);
		else if (ret == 2)
			return;
	}
	MShellDestroy(shell);
	MGUITerm();
	exit(0);
}

void GoToLineCB(MOBJECT p, void *od, void *ud)
{
	MOBJECT		shell = (MOBJECT)ud;
	FILE_DATA	*pfd = MObjectGetUserData(shell);

	shell = MDCreategotoline_shell();
	MObjectSetUserData(gotoline_ok_pb, pfd);
	MShellRealize(shell);
}

void SearchCB(MOBJECT p, void *od, void *ud)
{
	MOBJECT		shell = (MOBJECT)ud;
	FILE_DATA	*pfd = MObjectGetUserData(shell);
	int		curs_pos, len;
	char		buff[50];

	shell = MDCreatesearch_shell();
	MObjectSetUserData(search_f_pb, pfd);
	MObjectSetUserData(search_b_pb, pfd);
	MShellRealize(shell);
}

void SearchNextCB(MOBJECT p, void *od, void *ud)
{
	MOBJECT		shell = (MOBJECT)ud;
	FILE_DATA	*pfd = MObjectGetUserData(shell);
	int		curs_pos, end;

	if (pfd->search_text == NULL) {
		MBeep();
		return;
	}
	curs_pos = MEditGetCursorPos(pfd->edit);
	if ((curs_pos = MEditFindSubStringForward(pfd->edit, curs_pos, pfd->search_text, ignore_case)) >= 0) {
		end = curs_pos + strlen(pfd->search_text);
		MEditSetCursorPos(pfd->edit, end);
		MEditSetSelection(pfd->edit, curs_pos, end);
	}
	else
		MBeep();
}

void SearchPrevCB(MOBJECT p, void *od, void *ud)
{
	MOBJECT		shell = (MOBJECT)ud;
	FILE_DATA	*pfd = MObjectGetUserData(shell);
	int		curs_pos, end;

	if (pfd->search_text == NULL) {
		MBeep();
		return;
	}
	curs_pos = MEditGetCursorPos(pfd->edit);
	if ((curs_pos = MEditFindSubStringBackward(pfd->edit, curs_pos, pfd->search_text, ignore_case)) >= 0) {
		end = curs_pos + strlen(pfd->search_text);
		MEditSetCursorPos(pfd->edit, curs_pos);
		MEditSetSelection(pfd->edit, curs_pos, end);
	}
	else
		MBeep();
}

void ReplaceCB(MOBJECT p, void *od, void *ud)
{
	MOBJECT		shell = (MOBJECT)ud;
	FILE_DATA	*pfd = MObjectGetUserData(shell);
	int		curs_pos, len;
	char		buff[50];

	shell = MDCreatereplace_shell();
	MObjectSetUserData(replace_one_pb, pfd);
	MObjectSetUserData(replace_some_pb, pfd);
	MObjectSetUserData(replace_all_pb, pfd);
	MShellRealize(shell);
}

void FontSelectCB(MOBJECT p, void *od, void *ud)
{
	FILE_DATA		*pfd;
	MOBJECT			shell;

	shell = (MOBJECT)MObjectGetUserData(p);
	pfd = MObjectGetUserData(shell);
	if (selected_font_item)
		MSetItemCheckStatus(p, selected_font_item, False);
	selected_font_item = od;
	MSetItemCheckStatus(p, od, True);
	MObjectSetFont(pfd->edit, (MTFont)ud, True);
}

void ColorInvertCB(MOBJECT p, void *od, void *ud)
{
	MOBJECT		shell = (MOBJECT)ud;
	FILE_DATA	*pfd = MObjectGetUserData(shell);
	MTColor		bgc = MObjectBackgroundColor(pfd->edit);
	MTColor		fgc = MObjectForegroundColor(pfd->edit);

	MObjectSetColor(pfd->edit, fgc, bgc);
}

void TextChangedCB(MOBJECT p, EDIT_CHANGE *od, void *ad)
{
	FILE_DATA	*pfd;
	MOBJECT		shell;

	shell = MObjectShell(p);
	pfd = MObjectGetUserData(shell);
	if (pfd == NULL || pfd->modified)
		return;
	MObjectSetText(pfd->modified_label, "*");
	pfd->modified = True;
}

void CursorPosCB(MOBJECT p, EDIT_CURS *pc, void *ad)
{
	FILE_DATA	*pfd;
	MOBJECT		shell;
	char		buff[64];

	shell = MObjectShell(p);
	pfd = (FILE_DATA *)MObjectGetUserData(shell);
	if (pfd == NULL)
		return;
	sprintf(buff, "%4d", pc->pos_x + 1);
	MObjectSetText(pfd->curs_x_label, buff);
	sprintf(buff, "%4d", pc->pos_y + 1);
	MObjectSetText(pfd->curs_y_label, buff);
}
void IgnoreCaseCB(MOBJECT p, MVALUE od, void *ad)
{
	ignore_case = (int)od;
}

void SearchForwardCB(MOBJECT p, void *od, void *ad)
{
	FILE_DATA	*pfd = MObjectGetUserData(p);
	int		curs_pos, len;
	char		buff[50], str[64];

	MObjectGetText(search_e, buff);
	curs_pos = MEditGetCursorPos(pfd->edit);
	if ((curs_pos = MEditFindSubStringForward(pfd->edit, curs_pos, buff, ignore_case)) >= 0) {
		len = strlen(buff);
		MEditSetCursorPos(pfd->edit, curs_pos+len);
		MEditSetSelection(pfd->edit, curs_pos, curs_pos + len);
		if (pfd->search_text)
			free(pfd->search_text);
		pfd->search_text = malloc(len+1);
		strcpy(pfd->search_text, buff);
	}
	else {
		sprintf(str, "String:\n%s\nnot found", buff);
		MMessageDialog("Warning", str, " Ok " , NULL);
	}
	MShellDestroy(p);
}

void SearchBackwardCB(MOBJECT p, void *od, void *ad)
{
	FILE_DATA	*pfd = MObjectGetUserData(p);
	int		curs_pos, len;
	char		buff[50], str[64];

	MObjectGetText(search_e, buff);
	curs_pos = MEditGetCursorPos(pfd->edit);
	if ((curs_pos = MEditFindSubStringBackward(pfd->edit, curs_pos, buff, ignore_case)) >= 0) {
		len = strlen(buff);
		MEditSetCursorPos(pfd->edit, curs_pos+len);
		MEditSetSelection(pfd->edit, curs_pos, curs_pos + len);
		if (pfd->search_text)
			free(pfd->search_text);
		pfd->search_text = malloc(len+1);
		strcpy(pfd->search_text, buff);
	}
	else {
		sprintf(str, "String:\n%s\nnot found", buff);
		MMessageDialog("Warning", str, " Ok " , NULL);
	}
	MShellDestroy(p);
}

void SearchCancelCB(MOBJECT p, void *od, void *ad)
{
	MShellDestroy(p);
}

void GotolineOkCB(MOBJECT p, void *od, void *ad)
{
	FILE_DATA	*pfd = MObjectGetUserData(p);
	int		line;
	char		buff[16];

	MObjectGetText(gotoline_e, buff);
	line = atoi(buff);
	MEditSetCursorXY(pfd->edit, 0, line-1);
	MShellDestroy(p);
}

void GotolineCancelCB(MOBJECT p, void *od, void *ad)
{
	MShellDestroy(p);
}

void ReplaceCancelCB(MOBJECT p, void *od, void *ad)
{
	MShellDestroy(p);
}


/*
 * Shell creation functions
 */

MOBJECT MDCreatemain_shell(void)
{
	MOBJECT _rowform000;
	MOBJECT _menu000;
	MOBJECT _colform000;

	main_shell = MCreateShell("M-Edit 1.0", 0);
	MObjectSetBackgroundRGB(main_shell, 53, 112, 112);

	_rowform000 = MCreateRowForm(main_shell);
	MFormSetSpacing(_rowform000, 0);
	MObjectSetBackgroundRGB(_rowform000, 53, 112, 112);
	MObjectSetShadow(_rowform000, WS_NONE, 0, 0);

	{
	  MOBJECT	pd;
	  PULLDOWN_ITEM	item;

	  _menu000 = MCreateMenuBar(_rowform000, HELV_L_FONT);
	  MMenuSetAcc(_menu000, F10);
	  pd = MCreatePullDown(_menu000, "File");
	  item = MPullDownAddItem(pd, "Open ...", OpenCB, main_shell);
	  item = MPullDownAddItem(pd, "Save", SaveCB, main_shell);
	  item = MPullDownAddItem(pd, "Save As ...", SaveAsCB, main_shell);
	  item = MPullDownAddItem(pd, "Revert to saved", RevertCB, main_shell);
	  item = MPullDownAddItem(pd, "Quit", QuitCB, main_shell);
	  pd = MCreatePullDown(_menu000, "Search");
	  item = MPullDownAddItem(pd, "Go to Line ...", GoToLineCB, main_shell);
	  item = MPullDownAddItem(pd, "Search String ...", SearchCB, main_shell);
	  item = MPullDownAddItem(pd, "Search Next", SearchNextCB, main_shell);
	  item = MPullDownAddItem(pd, "Search Previous", SearchPrevCB, main_shell);
	  item = MPullDownAddItem(pd, "Replace ...", ReplaceCB, main_shell);
	  options_pd       = MCreatePullDown(_menu000, "Options");
	  default_font_i = MPullDownAddItem(options_pd      , "Medium Font", FontSelectCB, (void *)DEFAULT_FONT);
	  item = MPullDownAddItem(options_pd      , "Large Font", FontSelectCB, (void *)LARGE_FONT);
	  item = MPullDownAddItem(options_pd      , "Small Font", FontSelectCB, (void *)SMALL_FONT);
	  item = MPullDownAddItem(options_pd      , "Invert Color", ColorInvertCB, main_shell);
	}
	MObjectSetBackgroundRGB(_menu000, 160, 192, 144);

	_colform000 = MCreateColForm(_rowform000);
	MFormSetSpacing(_colform000, 1);
	MObjectSetBackgroundRGB(_colform000, 53, 112, 112);
	MObjectSetShadow(_colform000, WS_NONE, 0, 0);

	filename_l = MCreateLabel(_colform000, "", DEFAULT_FONT);
	MLabelSetAlignment(filename_l, LEFT_ALIGN);
	MObjectSetBackgroundRGB(filename_l, 197, 197, 144);
	MObjectSetShadow(filename_l, WS_SHADOW_OUT, 1, 0);

	modified_l = MCreateLabel(_colform000, " ", DEFAULT_FONT);
	MObjectSetBackgroundRGB(modified_l, 197, 197, 144);
	MObjectSetResize(modified_l, False, False);
	MObjectSetShadow(modified_l, WS_SHADOW_OUT, 1, 0);

	curs_y_l = MCreateLabel(_colform000, "    ", DEFAULT_FONT);
	MLabelSetAlignment(curs_y_l, RIGHT_ALIGN);
	MObjectSetBackgroundRGB(curs_y_l, 197, 197, 144);
	MObjectSetResize(curs_y_l, False, False);
	MObjectSetShadow(curs_y_l, WS_SHADOW_OUT, 1, 0);

	curs_x_l = MCreateLabel(_colform000, "    ", DEFAULT_FONT);
	MLabelSetAlignment(curs_x_l, RIGHT_ALIGN);
	MObjectSetBackgroundRGB(curs_x_l, 197, 197, 144);
	MObjectSetResize(curs_x_l, False, False);
	MObjectSetShadow(curs_x_l, WS_SHADOW_OUT, 1, 0);

	text_mle = MCreateScrolledMLEdit(_rowform000, "", 60, 20, DEFAULT_FONT);
	MEditSetValueChangeCallback(text_mle, TextChangedCB, NULL);
	MEditSetCursorPosCallback(text_mle, CursorPosCB, NULL);
	MObjectSetBackgroundRGB(text_mle, 53, 112, 112);
	MObjectSetForegroundRGB(text_mle, 224, 224, 176);
	MObjectSetResize(text_mle, True, True);
{
	FILE_DATA *pfd;

	pfd = (FILE_DATA *)calloc(1, sizeof(FILE_DATA));
	MObjectSetUserData(main_shell, pfd);
	if (pfd != NULL) {
		pfd->edit = text_mle;
		pfd->curs_x_label = curs_x_l;
		pfd->curs_y_label = curs_y_l;
		pfd->fname_label = filename_l;
		pfd->modified_label = modified_l;
	}
	MObjectSetUserData(options_pd, main_shell);
	selected_font_item = default_font_i;
	MSetItemCheckStatus(options_pd, default_font_i, True);
}


	return main_shell;
}

MOBJECT MDCreatesearch_shell(void)
{
	MOBJECT _colform001;

	search_shell = MCreateShell("Search String", 0|SF_MODAL);
	MObjectSetBackgroundRGB(search_shell, 192, 176, 160);

	search_e = MCreateEdit(search_shell, "", 40, DEFAULT_FONT);
	MTopAttach(search_e, F_ATT_FORM, 10, NULL);
	MLeftAttach(search_e, F_ATT_FORM, 10, NULL);

	ignore_case_tb = MCreateTButton(search_shell, "Ignore case", HELV_L_FONT);
	MTButtonSetCallback(ignore_case_tb, IgnoreCaseCB, NULL);
	MTopAttach(ignore_case_tb, F_ATT_OBJ, 10, search_e);
	MObjectSetBackgroundRGB(ignore_case_tb, 192, 176, 160);
MTButtonSetActivationStatus(ignore_case_tb, ignore_case);
	_colform001 = MCreateColForm(search_shell);
	MTopAttach(_colform001, F_ATT_OBJ, 10, ignore_case_tb);
	MObjectSetBackgroundRGB(_colform001, 160, 112, 112);

	search_f_pb = MCreatePButton(_colform001, "Forward", TIMES_L_FONT);
	MPButtonSetMargin(search_f_pb, 8, 2);
	MPButtonSetCallback(search_f_pb, SearchForwardCB, NULL);
	MObjectSetResize(search_f_pb, False, False);

	search_b_pb = MCreatePButton(_colform001, "Backward", TIMES_L_FONT);
	MPButtonSetMargin(search_b_pb, 8, 2);
	MPButtonSetCallback(search_b_pb, SearchBackwardCB, NULL);
	MObjectSetResize(search_b_pb, False, False);

	search_cancel_pb = MCreatePButton(_colform001, "Cancel", TIMES_L_FONT);
	MPButtonSetMargin(search_cancel_pb, 8, 2);
	MPButtonSetCallback(search_cancel_pb, SearchCancelCB, NULL);
	MObjectSetResize(search_cancel_pb, False, False);


	return search_shell;
}

MOBJECT MDCreategotoline_shell(void)
{
	MOBJECT _colform002;
	MOBJECT _pbutton000;

	gotoline_shell = MCreateShell("Go to Line", 0|SF_MODAL);
	MObjectSetBackgroundRGB(gotoline_shell, 112, 128, 112);

	gotoline_e = MCreateEdit(gotoline_shell, "", 6, DEFAULT_FONT);
	MEditSetFilter(gotoline_e, 4, "");
	MTopAttach(gotoline_e, F_ATT_FORM, 10, NULL);

	_colform002 = MCreateColForm(gotoline_shell);
	MTopAttach(_colform002, F_ATT_OBJ, 10, gotoline_e);
	MObjectSetBackgroundRGB(_colform002, 160, 144, 80);

	gotoline_ok_pb = MCreatePButton(_colform002, "Ok", TIMES_L_FONT);
	MPButtonSetMargin(gotoline_ok_pb, 20, 2);
	MPButtonSetCallback(gotoline_ok_pb, GotolineOkCB, NULL);
	MObjectSetResize(gotoline_ok_pb, False, False);

	_pbutton000 = MCreatePButton(_colform002, "Cancel", TIMES_L_FONT);
	MPButtonSetCallback(_pbutton000, GotolineCancelCB, NULL);
	MObjectSetResize(_pbutton000, False, False);


	return gotoline_shell;
}

MOBJECT MDCreatereplace_shell(void)
{
	MOBJECT _colform003;
	MOBJECT _rowform001;
	MOBJECT _label000;
	MOBJECT _label001;
	MOBJECT _rowform002;
	MOBJECT _colform004;

	replace_shell = MCreateShell("Replace", 0|SF_MODAL);
	MObjectSetBackgroundRGB(replace_shell, 112, 165, 160);

	_colform003 = MCreateColForm(replace_shell);
	MObjectSetBackgroundRGB(_colform003, 112, 165, 160);

	_rowform001 = MCreateRowForm(_colform003);
	MObjectSetBackgroundRGB(_rowform001, 112, 165, 160);
	MObjectSetShadow(_rowform001, WS_NONE, 0, 0);

	_label000 = MCreateLabel(_rowform001, "Replace", HELV_L_FONT);
	MLabelSetAlignment(_label000, RIGHT_ALIGN);
	MObjectSetBackgroundRGB(_label000, 112, 165, 160);

	_label001 = MCreateLabel(_rowform001, "With", HELV_L_FONT);
	MLabelSetAlignment(_label001, RIGHT_ALIGN);
	MObjectSetBackgroundRGB(_label001, 112, 165, 160);

	_rowform002 = MCreateRowForm(_colform003);
	MObjectSetBackgroundRGB(_rowform002, 112, 165, 160);
	MObjectSetShadow(_rowform002, WS_NONE, 0, 0);

	replace_r_e = MCreateEdit(_rowform002, "", 40, DEFAULT_FONT);

	replace_w_e = MCreateEdit(_rowform002, "", 40, DEFAULT_FONT);

	_colform004 = MCreateColForm(replace_shell);
	MFormSetSpacing(_colform004, 8);
	MObjectSetBackgroundRGB(_colform004, 53, 112, 112);

	replace_one_pb = MCreatePButton(_colform004, "One", TIMES_L_FONT);
	MObjectSetResize(replace_one_pb, False, False);

	replace_some_pb = MCreatePButton(_colform004, "Some", TIMES_L_FONT);
	MObjectSetResize(replace_some_pb, False, False);

	replace_all_pb = MCreatePButton(_colform004, "All", TIMES_L_FONT);
	MObjectSetResize(replace_all_pb, False, False);

	replace_canc_pb = MCreatePButton(_colform004, "Cancel", TIMES_L_FONT);
	MPButtonSetCallback(replace_canc_pb, ReplaceCancelCB, NULL);
	MObjectSetResize(replace_canc_pb, False, False);


	return replace_shell;
}

void MDQuitCB(MOBJECT shell, void *od, void *ad)
{
	if (MMessageDialog("", "Do you really want to quit ?", "Yes", "No", NULL))
		return;
	MShellUnrealize(shell);
	MShellDestroy(shell);
	MGUITerm();
	exit(0);
}

void MGUIMain(int argc, char **argv)
{
	MOBJECT shell;

	shell = MDCreatemain_shell();
	MShellRealize(shell);

	MShellSetWMCloseCallback(shell, MDQuitCB, 0L);
	MMainLoop();
}
