#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <values.h>

#include "mgui.h"

#include "me.h"

char *LoadFile(char *filename, int *ro)
{
	FILE		*fp;
	char		str[256];
	char		*buff;
	struct stat	sb;
	int		len, nread;

	if (stat(filename, &sb) == -1) {
		sprintf(str, "Accessing file:\n%s", filename);
		MMessageDialog("Error", str, " Ok ", NULL);
                return NULL;
	}
	if (sb.st_size > (long)MAXINT) {
		MMessageDialog("Sorry", "File is too large !", " Ok ", NULL);
		return NULL;
        }
	if ((fp=fopen(filename, "r+")) == NULL) {
		if ((fp=fopen(filename, "r")) == NULL) {
			sprintf(str, "Opening file:\n%s", filename);
			MMessageDialog("Error", str, " Ok ", NULL);
			return NULL;
		}
		*ro = True;
	}
	else {
		*ro = False;
	}
	if ((buff = malloc((int)sb.st_size)) == NULL) {
		MMessageDialog("ERROR", "Not Enough Memory,\nSorry", " Ok ", NULL);
		fclose(fp);
                return NULL;
	}
	nread = fread(buff, 1, (int)sb.st_size, fp);
	buff[nread] = '\0';
        return buff;
}

void OpenCB(MOBJECT p, void *od, void *ad)
{
	MOBJECT		shell = (MOBJECT)ad;
	FILE_DATA	*pfd = (FILE_DATA *)MObjectGetUserData(shell);
	char		str[256];
	char		*buff;

	if (pfd->pathname == NULL && (pfd->pathname = malloc(MAXPATHLEN)) == NULL) {
		MMessageDialog("ERROR", "Not Enough Memory,\nSorry", " Ok ", NULL);
		return;
	}
	if (pfd->filename == NULL && (pfd->filename = malloc(MAXFNAMELEN)) == NULL) {
		MMessageDialog("ERROR", "Not Enough Memory,\nSorry", " Ok ", NULL);
		goto err1;
	}
	pfd->filename[0] = '\0';
	pfd->pathname[0] = '\0';
	if (!MFileSelection("Open File", EXT, pfd->filename, pfd->pathname, True))
		goto err2;
	strcat(pfd->pathname, pfd->filename);
	if ((buff = LoadFile(pfd->pathname, &(pfd->read_only))) == NULL)
		goto err2;
	MObjectSetSensitivity(pfd->edit, !pfd->read_only);
        pfd->modified = False;
        MObjectSetText(pfd->modified_label, pfd->read_only ? "R" : " ");
	MObjectSetText(pfd->fname_label, pfd->pathname);
	MObjectSetText(pfd->edit, buff);
	free(buff);
	return;
err2:
	free(pfd->filename);
	pfd->filename = NULL;
err1:
	free(pfd->pathname);
	pfd->pathname = NULL;
}

void SaveCB(MOBJECT p, void *od, void *ad)
{
	MOBJECT		shell = (MOBJECT)ad;
	FILE_DATA	*pfd = (FILE_DATA *)MObjectGetUserData(shell);
	FILE		*fp;
	char		str[256];
	char		*buff;

	if (pfd->pathname == NULL) {
		MMessageDialog("Warning", "No file open !", " Ok ", NULL);
		return;
	}
	if (pfd->read_only) {
		sprintf(str, "File: %s\nis read only!", pfd->pathname);
		MMessageDialog("Warning", str, " Ok ", NULL);
		return;
	}
	if (!pfd->modified) {
		sprintf(str, "File:\n%s\nhas not been modified.\nSave anyway ?", pfd->pathname);
		if (MMessageDialog("Warning", str, " Yes ", " Abort", NULL) != 0)
			return;
	}
	if ((fp = fopen(pfd->pathname, "w")) == NULL) {
		sprintf(str, "Cannot open file:\n%s\nfor writing!", pfd->pathname);
		MMessageDialog("Warning", str, " Ok ", NULL);
		return;
	}
	buff = MObjectGetText(pfd->edit, NULL);
	if (buff) {
		fwrite(buff, 1, strlen(buff), fp);
		free(buff);
	}
	fclose(fp);
	pfd->modified = False;
	MObjectSetText(pfd->modified_label, " ");
}

void SaveAsCB(MOBJECT p, void *od, void *ad)
{
	MMessageDialog("Warning", "Function Not Implemented,\nsorry", " Ok ", NULL);
}

void RevertCB(MOBJECT p, void *od, void *ad)
{
	MOBJECT		shell = (MOBJECT )ad;
	FILE_DATA	*pfd = (FILE_DATA *)MObjectGetUserData(shell);
	char		str[256];
	char		*buff;

	if (pfd->pathname == NULL) {
		MMessageDialog("Warning", "No file open !", " Ok ", NULL);
		return;
	}   
	sprintf(str, "Are you sure you want to reload:\n\n%s ?\n", pfd->pathname);
	if (MMessageDialog("", str, " Yes ", " Abort ", NULL) != 0)
		return;
	if ((buff = LoadFile(pfd->pathname, &(pfd->read_only))) == NULL)
        	return;
	pfd->modified = False;
	MObjectSetText(pfd->modified_label, pfd->read_only ? "R" : " ");
	MObjectSetText(pfd->edit, buff);
	free(buff);
}
